*  Program...........: PRMMENU.PRG
*  Author............:  Andrew Ross MacNeill
*  Created...........: 05/18/94
*) Description.......: MNXDRV0 to create old-style FoxBase+ Menus
*)                     Contains replacement calls for GENMENU
*  Calling Samples...: 
*  Parameter List....: 
*( Major change list.: 

*
* DEFINEMENU - Define main menu and its pads.
*
* Description:
* Issue DEFINE MENU ... command.
* Call a procedure to define all menu pads.
* Call a procedure to generate ON PAD statements when appropriate.
*
PROCEDURE definemenu
*) New Define menu that creates a box around an area in the screen
    IF m.g_graphic
        SET MESSAGE TO 'Generating menu definitions...'
    ENDIF
    DO commentblock WITH "menu"
    SELECT (g_mnxfile[4])
    LOCATE FOR objtype = c_menu
	RELEASE m._ox,m._oy, m._x, m._y, m._xItems, m._xIncrement, m._yIncrement
	PUBLIC m._ox,m._oy, m._x, m._y, m._xItems, m._xIncrement, m._yIncrement
	RELEASE lcWin, _origx, _origY
	PUBLIC lcWin, _origx, _origY
	lcWin=[]
	m._ox=5
	m._oy=3
	m._origx=5
	m._origy=3
	m._x=5
	m._y=3
	m._xIncrement=1
	m._yIncrement=0
	RELEASE jPad, llWin, lcWinClauses, lcCUIClauses
	PUBLIC jPad, llWin, lcWinClauses, lcCuiClauses
	jPad=1
	lcWin=wordSearch([*:DEFWIN],"setup")
	lcWinClauses=wordSearch([*:WINCLAUSE],"setup")
	lcCUIClauses=wordSearch([*:DOSCLAUSE],"setup")
	IF NOT EMPTY(lcWin) AND NOT lcWin=CHR(0)
		llWin=.T.
	ELSE
		llWin=.F.
	ENDIF

	jcTemp=wordSearch([*:CASCADE],"setup")
	IF NOT EMPTY(jcTemp)
		jnJunk=IIF(OCCURS([,],jcTemp)>0,ATC(",",jcTemp,1),LEN(jcTemp))
		jnX=LEFT(jcTemp,jnJunk-1)
		IF OCCURS([,],jcTemp)>0
			jnY=STRTRAN(jcTemp,jnx+[,])
		ELSE
			jny=[0]
		ENDIF
		m._xIncrement=VAL(jnx)
		m._yIncrement=VAL(jny)
	ENDIF
    m.g_location = location
    m.g_padloca  = ALLTRIM(name)
    
    LOCATE FOR objtype = c_submenu AND objcode = c_global
    
    m.g_menucolor = SCHEME
    m.g_menumark  = MARK
    \SET SYSMENU TO
    \
    \SET SYSMENU AUTOMATIC
    \
    \
    DO defmenupads
    DO defonpad
    \
    \CLEAR
    \
    \SET SYSMENU TO DEFAULT
    \
    DO updtherm WITH 25
    
*
* DEFMENUPADS - Define all pads for the menu bar.
*
* Description:
* Scan the menu database for all objects of the type item which
* have the levelname=_MSYSMENU.
* For each such item, generate a statement DEFINE PAD... where
* the name of the pad is the contents of NAME field or (if Name
* field is empty) an automatically generated name.
* Call procedures addkey, addskipfor, and mark to generate
* KEY, SKIPFOR, or MARK clauses when appropriate.
*
PROCEDURE defmenupads
    PRIVATE m.padname, m.prompt, jnRec
	jPad=LOWER(SYS(2015))
	m.prompt=[ ]
	jnRec=RECNO()
	GO TOP
	m.prompt=wordsearch("*:MAINTITLE","setup")
	IF m.prompt=CHR(0)
		m.prompt=[]
	ENDIF
	GO (jnRec)
	\
	\<<jPad>>=1
	\
	\DO WHILE NOT <<jPad>>=0
	\
	IF llWin
		\DO CASE
		\	CASE _WINDOWS
		\		DEFINE WINDOW <<lcWin>> FROM <<m._ox-5>>,<<m._oy-3>> TO <<m._ox+(numItems*m._xIncrement)>>,<<m._y+35>> <<lcWinClauses>> 
		IF NOT "TITLE"$lcWinClauses AND NOT EMPTY(m.prompt)
			\\TITLE <<m.prompt>>
		ENDIF
		\	CASE _DOS
		\		DEFINE WINDOW <<lcWin>> FROM <<m._ox-5>>,<<m._oy-3>> TO <<m._ox+(numItems*m._xIncrement)>>,<<m._y+35>> <<lcCUIClauses>> 
		IF NOT "TITLE"$lcCuiClauses AND NOT EMPTY(m.prompt)
			\\TITLE <<m.prompt>>
		ENDIF
		\	CASE _MAC
		\		DEFINE WINDOW <<lcWin>> FROM <<m._ox-5>>,<<m._oy-3>> TO <<m._ox+(numItems*m._xIncrement)>>,<<m._y+35>> <<lcWinClauses>> 
		IF NOT "TITLE"$lcWinClauses AND NOT EMPTY(m.prompt)
			\\TITLE <<m.prompt>>
		ENDIF
		\	CASE _UNIX
		\		DEFINE WINDOW <<lcWin>> FROM <<m._ox-5>>,<<m._oy-3>> TO <<m._ox+(numItems*m._xIncrement)>>,<<m._y+35>> <<lcCuiClauses>> 
		IF NOT "TITLE"$lcCuiClauses AND NOT EMPTY(m.prompt)
			\\TITLE <<m.prompt>>
		ENDIF
		\ENDCASE
		\
		\MOVE WINDOW <<lcWin>> CENTER
		\
		** Identify new m._ox
		m._origx=m._ox
		m._origy=m._oy
		m._xItems=numItems
		
		\ACTIVATE WINDOW <<lcWin>>
		m._x=1
	ELSE
		\
		\SET TALK OFF
		\
		** \@ <<m._ox-5>>,<<m._oy-3>> TO <<m._ox+(numItems*m._xIncrement)+2>>,<<m._y+35>>
		m._x=(SROWS()/2)-(numItems*_xIncrement/2)
		m._xItems=numitems*_xIncrement
		m._ox=m._x
		m._y=(SCOLS()/2)-15
		m._oy=m._y
	ENDIF
	IF NOT llWin
		\
		\@ <<m._ox-2>>,SCOLS()/2-20 TO <<m._ox+(numItems*m._xIncrement)+1>>,SCOLS()/2+20
		IF NOT EMPTY(lcCuiClause) AND NOT lcCuiClause=CHR(0)
			\\ <<lcCuiClause>>
		ENDIF
	ENDIF
	\	
	\@ <<m._ox-1>>,<<m._oy-1>> CLEAR TO <<m._ox+(numItems*m._xIncrement)>>,<<m._y+30>>
	\
	
    SCAN FOR objtype=c_item AND UPPER(levelname)="_MSYSMENU"
        IF NOT EMPTY(ALLTRIM(name))
            g_pads[VAL(Itemnum)] = name
        ELSE
            g_pads[VAL(Itemnum)] = LOWER(SYS(2015))
        ENDIF
		\@ <<m._x>>,<<m._y>>  
        ** \DEFINE BAR <<VAL(Itemnum)>> OF _MSYSMENU
        ** \DEFINE BAR <<g_pads[VAL(Itemnum)]>> OF _MSYSMENU
        m._x=m._x+m._xIncrement
        
        IF MOD(VAL(itemnum),25)=0
            DIMENSION g_pads[VAL(Itemnum)+25]
        ENDIF
        m.prompt = SUBSTR(PROMPT,1,LEN(PROMPT))
        \\ PROMPT "<<m.prompt>>"
        ** \\ COLOR SCHEME <<m.g_menucolor>>
        
    ENDSCAN
    
    DO updtherm WITH 35
    \
    \MENU TO <<jPad>>
    \
    
*
* DEFONPAD - Generate ON PAD... statements.
*
* Description:
* Generate ON PAD statements for each pad off of the main menu which
* has a submenu associated with it.
* For pads which have no submenus, but there is a command associated
* with them, issue ON SELECTION PAD... statements.  If the code
* associated with a pad is a snippet, then issue a call to the
* generated procedure and place the snippet code in it.
*
PROCEDURE defonpad
    PRIVATE m.padname
    \
    \DO CASE
    SCAN FOR objtype=c_item AND UPPER(levelname)="_MSYSMENU"
        m.padname = VAL(Itemnum)
        SKIP
        IF objtype=c_submenu AND numitems<>0
			\
        	\	CASE <<jPad>>=<<m.padName>>
        	IF NOT llWin
				\		@ <<m._ox-1>>,<<m._oy-1>> CLEAR TO <<m._ox+m._xItems>>,<<m._y+30>>
			ENDIF
        	\		DO _<<LOWER(name)>>
        	\
            SKIP -1
        ELSE
            SKIP -1
			\
        	\	CASE <<jPad>>=<<m.padName>>
        	\
            DO onselection WITH "POPUP", m.padname, 'main'
        ENDIF
    ENDSCAN
    \
    \ENDCASE
    \
    \
    \ENDDO
    \
	\@ <<m._ox-1>>,<<m._oy-1>> CLEAR TO <<m._ox+m._xItems>>,<<m._y+30>>
    \
    \RELEASE WINDOW <<lcWin>>
    \

    DO updtherm WITH 45
    
*
* DEFINEPOPUPS - Define popups and their bars.
*
* Description:
* Scan the Menu database to find all objecttypes = submenu.
* They all correspond to popups.  For each such object found, issue
* command DEFINE POPUP....  Add MARK, KEY, and SKIP FOR clauses
* if appropriate by calling procedures to handle these tasks.  Call
* procedure Defbars to define all bars of each popup.
*
PROCEDURE definepopups
    PRIVATE m.savrecno, m.popname, m.sch
    IF m.g_graphic
        SET MESSAGE TO 'Generating popup definitions...'
    ENDIF
    SCAN FOR objtype=c_submenu AND UPPER(levelname)<>"_MSYSMENU" ;
            AND numitems <> 0
        
        m.savrecno = RECNO()
        m.popname  = ALLTRIM(LOWER(levelname))
        m.sch      = SCHEME
        
		\
        \PROCEDURE _<<LOWER(Name)>>
        \
        DO defbars WITH m.popname, numitems
        DO defonbar WITH m.popname
        \
        GOTO RECORD m.savrecno
    ENDSCAN
    DO updtherm WITH 65
    
*
* DEFBARS - Define bars for each popup.
*
* Description:
* Scan the menu database for all objects of the type item whose
* name equals to the current popup name.
* For each such item, generate a statement DEFINE BAR....
* Call procedures addkey, addskipfor, and addmark to generate
* KEY, SKIPFOR, or MARK clauses when appropriate.
*
PROCEDURE defbars
    PARAMETER m.popname, m.howmany, m.name
    PRIVATE m.itemno, m.prompt
    m.prompt=[]
 	m._x=m._ox
	m._y=m._oy
	jPad=LOWER(SYS(2015))
    m._y=m._y
    \STORE 1 TO <<jPad>>
	\
	IF llWin
		\DO CASE
		\	CASE _WINDOWS
		\		DEFINE WINDOW _<<m.popName>> FROM WLROW(WONTOP()),WLCOL(WONTOP()) SIZE <<(numItems*m._xIncrement)+1>>,30 <<lcWinClauses>>  
		IF NOT "TITLE"$lcWinClauses
			\\TITLE "<<PROPER(m.popName)>>"
		ENDIF
		\	CASE _DOS
		\		DEFINE WINDOW _<<m.PopName>> FROM WLROW(WONTOP()),WLCOL(WONTOP()) SIZE <<(numItems*m._xIncrement)+1>>,30 <<lcCUIClauses>> 
		IF NOT "TITLE"$lcCuiClauses
			\\TITLE " <<PROPER(m.popName)>> "
		ENDIF
		\	CASE _MAC
		\		DEFINE WINDOW _<<m.popName>> FROM WLROW(WONTOP()),WLCOL(WONTOP()) SIZE <<(numItems*m._xIncrement)+1>>,30 <<lcWinClauses>> 
		IF NOT "TITLE"$lcWinClauses
			\\TITLE "<<PROPER(m.popName)>>"
		ENDIF
		\	CASE _UNIX
		\		DEFINE WINDOW _<<m.popName>> FROM WLROW(WONTOP()),WLCOL(WONTOP()) SIZE <<(numItems*m._xIncrement)+1>>,30 <<lcCuiClauses>> 
		IF NOT "TITLE"$lcCuiClauses
			\\TITLE " <<PROPER(m.popName)>> "
		ENDIF
		\ENDCASE
		\
		** \MOVE WINDOW _<<m.popName>> CENTER
		** \
		\MOVE WINDOW _<<m.popName>> BY <<m._xIncrement>>,<<m._yIncrement>>
		\
		\ACTIVATE WINDOW _<<m.popName>>
		\
		m._x=1
	ELSE
		** \@ <<m._ox>>,<<m._oy>> TO <<m._ox+(numItems*m._xIncrement)+m._xItems>>,<<m._y+30>>
		m._x=(SROWS()/2)-(numItems*_xIncrement/2)
		m._y=(SCOLS()/2)-15
	ENDIF
	\
	\DO WHILE NOT <<jPad>>=0
	\
    SCAN FOR objtype=c_item AND LOWER(levelname)=m.popname
        m.itemno = ALLTRIM(itemnum)
		\@ <<m._x>>,<<m._y>>  
        m._x=m._x+m._xIncrement
        m.prompt = SUBSTR(PROMPT, 1,LEN(PROMPT))
        \\ PROMPT "<<m.prompt>>"
        IF VAL(m.itemno)=m.howmany
            DO updtherm WITH 75
            EXIT
        ENDIF
    ENDSCAN
    \
    \MENU TO <<jPad>>
    \
*
* DEFONBAR - Generate ON BAR... statements.
*
* Description:
* Generate ON BAR statements for each popup.
* For bars which have no submenus, but there is a command associated
* with them, issue ON SELECTION BAR... statements.  If a snippet is
* associated with the code then generate a call statement to the
* generated procedure containing the snippet code.
*
PROCEDURE defonbar
    PARAMETER m.popname
    PRIVATE m.itemno
    
    \
    \DO CASE
    \
    SCAN FOR objtype=c_item AND LOWER(levelname)=m.popname
        m.itemno = ALLTRIM(itemnum)
        SKIP
        IF objtype=c_submenu AND numitems<>0
        	\	CASE <<jPad>>=<<m.Itemno>>
			** \@ <<m._ox-3>>,<<m._oy-1>> CLEAR TO <<m._ox+m._xItems>>,<<m._y+30>>
        	\		DO _<<LOWER(name)>>
        	\
            SKIP -1
        ELSE
            SKIP -1
			\
        	\	CASE <<jPad>>=<<m.itemno>>
        	\
            DO onselection WITH "BAR", m.itemno, m.popname
        ENDIF
    ENDSCAN
    \
    \ENDCASE
    \
    \ENDDO
    \
    \RELEASE WINDOW _<<m.popName>>
    \
    DO updtherm WITH 85
   
*
* ONSELECTION - Generate ON SELECTION... statements for menu items.
*
* Description:
* For pads and bars which have no submenu associated with them but
* instead have a non-empty Command field in the database, issue
* the ON SELECTION <command> statements.  If a snippet is associated
* with a pad then issue a call statement to the generated procedure
* containing the snippet.  Generated snippet procedure will be
* appended to the end of the output file.
*
PROCEDURE onselection
    PARAMETER m.which, m.name, m.ofname, m.commd
    PRIVATE m.trimname, m.basename
    IF EMPTY(PROCEDURE) AND EMPTY(COMMAND)
        RETURN
    ENDIF
    ** \\ OF <<m.ofname>>
    IF objcode = c_proc
        DO gensnippname
        m.trimname = SYS(2014,m.g_outfile,m.g_homedir)
        m.trimname = stripext(m.trimname)
        m.basename = basename(m.trimname)
        \	DO <<g_snippets[g_nsnippets,1]>> ;
        \	IN LOCFILE("<<m.trimname>>"
        \\ ,"MPX;MPR|FXP;PRG"
        \\ ,"Where is <<m.basename>>?")
    ELSE
        m.commd = COMMAND
        \\ <<m.commd>>
    ENDIF

PROCEDURE cleanup
    PRIVATE m.delilen, m.ldelimi, m.rdelimi
    IF EMPTY(m.g_projalias)
        RETURN
    ENDIF
    SELECT (m.g_projalias)
    USE
    IF NOT EMPTY(g_mnxfile[3])
        IF USED(g_mnxfile[4])
            SELECT (g_mnxfile[4])
            USE
        ENDIF
    ENDIF
    SELECT (m.g_workarea)
    
    m.delilen = LEN(m.delimiters)
    m.ldelimi = SUBSTR(m.delimiters,1,;
        IIF(MOD(m.delilen,2)=0,m.delilen/2,CEILING(m.delilen/2)))
    m.rdelimi = SUBSTR(m.delimiters,;
        IIF(MOD(m.delilen,2)=0,m.delilen/2+1,CEILING(m.delilen/2)+1))
    SET TEXTMERGE DELIMITERS TO m.ldelimi, m.rdelimi
    
    IF m.bell = "ON"
        SET BELL ON
    ENDIF
    IF m.cursor = "ON"
        SET CURSOR ON
    ELSE
        SET CURSOR OFF
    ENDIF
    IF m.consol = "ON"
        SET CONSOLE ON
    ENDIF
    IF m.escape = "ON"
        SET ESCAPE ON
    ELSE
        SET ESCAPE OFF
    ENDIF
    IF m.print = "ON"
        SET PRINT ON
    ENDIF
    IF m.exact = "OFF"
        SET EXACT OFF
    ENDIF
    IF m.fixed = "OFF"
        SET FIXED OFF
    ENDIF
    SET DECIMALS TO m.deci
    SET MEMOWIDTH TO m.memowidth
    SET DEVICE TO &mdevice
    IF m.trbetween = "ON"
        SET TRBET ON
    ENDIF
    IF m.comp = "ON"
        SET COMPATIBLE ON
    ENDIF
    IF m.talkstate = "ON"
        SET TALK ON
    ENDIF
    SET POINT TO "&mpoint"
    SET COLLATE TO "&mcollate"
    SET MESSAGE TO
	RELEASE ALL LIKE _*, _o*, _x*, _y*
	RELEASE jPad, lcWin, llWin, lcWinClaus, lcCuiClaus
	RELEASE _x, _y, _ox, _oy, _xincrement, _yincrement
	RELEASE _xItems, _yItems, _origX, _origY
    ON ERROR &onerror
   
    
